// AbortDocDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AbortDocDemo.h"
#include "AbortDocDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CAbortDocDemoDlg dialog



CAbortDocDemoDlg::CAbortDocDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAbortDocDemoDlg::IDD, pParent)
  , m_strPrinter(_T(""))
  , m_nPages(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAbortDocDemoDlg::DoDataExchange(CDataExchange* pDX)
{
  DDX_Text(pDX, IDC_EDIT1, m_strPrinter);
  DDX_Text(pDX, IDC_EDIT2, m_nPages);
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAbortDocDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDCANCEL2, OnBnClickedCancel2)
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CAbortDocDemoDlg message handlers

BOOL CAbortDocDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAbortDocDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAbortDocDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAbortDocDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CAbortDocDemoDlg::OnBnClickedCancel2()
{
  CAboutDlg().DoModal();
}

void CAbortDocDemoDlg::OnBnClickedOk()
{
  if (UpdateData())
  {
    try
    {
      HDC hdc = StartPrintJob();
      StartProgressDlg();

      DOCINFO di;
      ZeroMemory(&di, sizeof(DOCINFO));
      di.cbSize = sizeof(DOCINFO);
      di.lpszDocName = "AbortDoc Test";
      StartDocument(hdc, di);

      for (int i = 0; 
            i < m_nPages && !m_dlgStop.m_bAborted;
            i++)
      {
        StartPage(hdc);

        CString str;
        str.Format("Printing page %ld of %ld", (i+1), m_nPages);
        m_dlgStop.SetCaption(str);

        Print(hdc, (i+1));

        m_dlgStop.m_progress.SetPos(i + 1);

        EndPage(hdc);

        m_dlgStop.PeekAndPump();
      }

      EndDocument(hdc);
      EndProgressDlg();
      EndPrintJob(hdc);
    }
    catch(char* pz)
    {
      AfxMessageBox(pz);
    }
  }
}

HDC CAbortDocDemoDlg::StartPrintJob()
{
  HDC hdc = ::CreateDC("WINSPOOL", 
                        m_strPrinter, 
                        NULL, 
                        NULL);
  if (!hdc)
  {
    throw "Could not acquire a printer dc. "
                 "Do you have a printer installed? "
                 "If so, check the name and make sure "
                 "you entered it correctly.";
  }

  return hdc;
}

void CAbortDocDemoDlg::StartProgressDlg()
{
  if (!m_dlgStop.GetSafeHwnd())
  {
    m_dlgStop.Create(IDD_PROGRESS);
  }
  m_dlgStop.m_bAborted = FALSE;
  m_dlgStop.ShowWindow(SW_SHOW);

  // Set the dialogs progress bar.
  m_dlgStop.m_progress.SetRange(0, m_nPages);

  // Disable the main window.
  EnableWindow(FALSE);
}

void CAbortDocDemoDlg::StartDocument(HDC const& hdc, DOCINFO const& di)
{
  if (SP_ERROR == ::StartDoc(hdc,&di))
    throw "Could not start the printing process (::StartDoc).";
}

void CAbortDocDemoDlg::StartPage(HDC const& hdc)
{
  if (!::StartPage(hdc))
    throw "Error calling ::StartPage";
}

void CAbortDocDemoDlg::Print(HDC const& hdc, int counter)
{
  // Simulate getting data to print
  ::Sleep(1000);

  CString strText;
  strText.Format("Page %ld - AbortDoc Test",  counter);

  ::TextOut(hdc, 
            10, 10, 
            strText, 
            strText.GetLength());
}

void CAbortDocDemoDlg::EndPage(HDC const& hdc)
{
  if (!::EndPage(hdc))
    throw "Error calling::EndPage";
}

void CAbortDocDemoDlg::EndDocument(HDC const& hdc)
{
  if (!::EndDoc(hdc))
    throw "Error calling ::EndDoc";
}

void CAbortDocDemoDlg::EndProgressDlg()
{
  // Destroy the Stop dialog.
  m_dlgStop.DestroyWindow();

  // Re-enable the main dialog box and 
  // set focus to it.
  EnableWindow(TRUE); 
  SetFocus();   
}

void CAbortDocDemoDlg::EndPrintJob(HDC const& hdc)
{
  if (!::DeleteDC(hdc))
    throw "Error calling ::DeleteDC";
}
